
volatile byte score =0;

byte randomPin=2;
byte ledCounter=0; 
byte missedLed=0; 

unsigned int ledOff = 1000;
unsigned int ledOn = 1000;

void setup() {
Serial.begin(9600);
DDRC = 15; // A0..A3 Output
DDRB = 48;   //D8...D11  INPUT, D12 and D13 Output
PORTB = 15; //D8...D11 High impedance
DDRD = 60;  //D2...D5 OUTPUT
PORTD = 192; //D6 D7 High impedance
PCICR = 5;  // enable pin change interrupt bank 0 and 2
PCMSK0 = 15; //enable pin change interrupt PCINT0...PCINT3/D8...D11
PCMSK2 =192;  // enable pin change interrupt PCINT22/D6 D7
}
void loop() {
start(randomPin,ledOn,ledOff);
}

ISR(PCINT0_vect) {
for (byte i=0; i<4; i++) {
if (bitRead(PINB,i)==0 && bitRead(PIND,2+i)==1) {score++; bitClear(PORTD, 2+i);}
  }
 }

ISR(PCINT2_vect) {
for (byte i=0; i<2; i++) {
if (bitRead(PIND,i+6)==0 && bitRead(PINB,i+4)==1) {score++; bitClear(PORTB,i+4);}
  }
 }

void start(int led, int onTime, int offTime) 
{
  static byte Power =1;
  static unsigned long buttonTime;
  unsigned long Start;
  Start = millis();
  if (((Start-buttonTime)>=onTime) && (Power==1))
  {
  digitalWrite(randomPin, LOW);
  ledCounter++;
  results();
  do {randomPin = random(2,14);}
  while (randomPin>5 && randomPin<12);
  Power=0;
  }
  
  if (((Start-buttonTime)>=(offTime+=onTime)) && (Power==0) && (missedLed<4))
  {
  digitalWrite(randomPin, HIGH);
  difficulty();
  Power=1;
  buttonTime=millis();
  }
}
 
void results() {
  missedLed = (ledCounter-1) - score;
  if (missedLed>0) bitSet(PORTC,missedLed-1);
  Serial.print("trafiony "); Serial.println(score);
  Serial.print("opuszczone :"); Serial.println(missedLed);
}
 
void difficulty() {
  if (ledOn>500) {ledOff -= 15; ledOn -= 15;}
  else if (ledOn>100 && ledOn<=500) {ledOff -= 3; ledOn-=2;}
  Serial.print("led off ms "); Serial.println(ledOff);
}
